<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 11.10.01 - Build 20.10.2011
 * Lizenziert unter 'Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)'
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
$DA->KonsolenAusgabe('Beginn der Datenverarbeitung',1);
	if ( !is_dir($einstellungen['zwischenspeicher']['speicher_pfad']) )
	$DA->KonsolenAusgabe('Das Verzeichnis für den Zwischenspeicher existiert nicht',-1);
	if ( !is_writable($einstellungen['zwischenspeicher']['speicher_pfad']) )
	$DA->KonsolenAusgabe('Das Verzeichnis für den Zwischenspeicher ist schreibgeschützt',-1);
	if ( strlen($DA->cli_parameter['station']) < 4 )
	$DA->KonsolenAusgabe('Es wurde keine Station mit "--station=[name]" angegeben',-1);
	if ( !isset($einstellungen['daten'][$DA->cli_parameter['station']]) )
	$DA->KonsolenAusgabe('Diese Station befindet sich nicht in der Konfiguration',-1);

$DA->KonsolenAusgabe('Importiere Daten der Station '.$DA->cli_parameter['station'],1);
$datum_reihe = array('18000101','20990101');
$pruefsummen = array();
$socket_optionen_roh = array(
	'http'=>array(
		'protocol_version'=>1.1,
		'method'=>'GET',
		'header'=>"User-Agent: Wetter-Analyse in Dekaden/".WADE_VERSION_STRING." (http://taw-wade.kilu.de/)\r\n",
		)
);
	if ( $einstellungen['proxy']['http_benutzen'] && strlen($einstellungen['proxy']['http_hostname']) > 7 ){
	$socket_optionen_roh['http']['proxy'] = 'tcp://'.$einstellungen['proxy']['http_hostname'];
	$socket_optionen_roh['http']['request_fulluri'] = $einstellungen['proxy']['volle_uri_senden'];
	}

	foreach ( $einstellungen['daten'][$DA->cli_parameter['station']]['roh_daten'] as $id=>$datei ){
	$uuid = sprintf('%u',crc32($datei));
	$herunterladen = 0;
	$lokaler_pfad = $einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$DA->cli_parameter['station'].'.'.$uuid;
	$socket_optionen = $socket_optionen_roh;
	$DA->KonsolenAusgabe('Bearbeite Roh-Datei #'.$id.' - '.basename($datei),2);

		if ( file_exists($lokaler_pfad) ){
		$DA->KonsolenAusgabe('Im Zwischenspeicher gefunden. Schaue nach, ob sie noch aktuell ist...',2);
			switch ( $einstellungen['daten'][$DA->cli_parameter['station']]['aktualisieren'] ){
			case 'http-get-dateigroesse':
			$context = stream_context_create($socket_optionen);
			$daten = file_get_contents($datei,false,$context,0,100);
				if ( !$daten ){
				$DA->KonsolenAusgabe('Konnte keine Verbindung zum HTTP-Server aufbauen',2);
				$DA->KonsolenAusgabe('Überspringe aktuelle Roh-Datei #'.$id,2);
				continue 2;
				}
			$header = implode("\r\n",$http_response_header);
			$DA->KonsolenAusgabe('filesize(cached_file): '.(int)filesize($lokaler_pfad),3);
			$DA->KonsolenAusgabe(print_r($header,true),3);
			preg_match('/^Content-Length: (\d+)/im',$header,$datei_groesse);
				if ( isset($datei_groesse[1]) && (int)$datei_groesse[1] > (int)filesize($lokaler_pfad) ){
				$DA->KonsolenAusgabe('Neuere Version auf dem HTTP-Server gefunden',2);
				$herunterladen = (int)$datei_groesse[1];
					if ( !$einstellungen['daten'][$DA->cli_parameter['station']]['aktualisieren_nur_neues'] )
					unlink($lokaler_pfad);
				}
				else{
				$DA->KonsolenAusgabe('Der HTTP-Server meldet sie als aktuell',2);
				$herunterladen = -1;
				}
			break;
			case 'file-dateigroesse':
			$datei_groesse = filesize($datei);
				if ( !$datei_groesse ){
				$DA->KonsolenAusgabe('Konnte Datei in lokaler Quelle nicht finden',2);
				$DA->KonsolenAusgabe('Überspringe aktuelle Roh-Datei #'.$id,2);
				continue 2;
				}
			$DA->KonsolenAusgabe('filesize(cached_file): '.(int)filesize($lokaler_pfad),3);
				if ( (int)$datei_groesse > (int)filesize($lokaler_pfad) ){
				$DA->KonsolenAusgabe('Neuere Version in lokaler Datei gefunden',2);
				$herunterladen = (int)$datei_groesse;
					if ( !$einstellungen['daten'][$DA->cli_parameter['station']]['aktualisieren_nur_neues'] )
					unlink($lokaler_pfad);
				}
				else{
				$DA->KonsolenAusgabe('Der lokale Quelle meldet sie als aktuell',2);
				$herunterladen = -1;
				}
			break;
			default: $herunterladen = -1; break;
			}
		}
		else
		$DA->KonsolenAusgabe('Nicht im Zwischenspeicher gefunden',2);

		if ( $herunterladen > -1 ){
			switch ( $einstellungen['daten'][$DA->cli_parameter['station']]['aktualisieren'] ){
			case 'http-get-dateigroesse':
			$DA->KonsolenAusgabe('Lade Datei von der HTTP-Quelle herunter',2);
				if ( $einstellungen['daten'][$DA->cli_parameter['station']]['aktualisieren_nur_neues'] && file_exists($lokaler_pfad) ){
				$socket_optionen['http']['header'] .= "Range: bytes=".intval(filesize($lokaler_pfad))."-".($herunterladen-1)."\r\n";
				$DA->KonsolenAusgabe('Fordere nur die neuen Daten (letzten '.intval($herunterladen-filesize($lokaler_pfad)).' Bytes) vom Server an',2);
				}
			$context = stream_context_create($socket_optionen);
			$daten = file_get_contents($datei,false,$context);
/*				// DWD sendet ein überflüssiges 0x1a ("SUB" -> ^Z) am Ende mit...
				if ( $einstellungen['daten'][$DA->cli_parameter['station']]['typus'] === 'dwd_kl2000'
					&& substr($daten,-1) === chr(0x1a) )
				$daten = substr($daten,0,-1);*/

			$header = implode("\r\n",$http_response_header);
			$DA->KonsolenAusgabe(print_r($header,true),3);
				if ( $daten && strlen($daten) > 2048 ){
					if ( stripos($header,'206 partial content') ){
					$daten = file_put_contents($lokaler_pfad,$daten,FILE_APPEND|LOCK_EX);
					$DA->KonsolenAusgabe($daten.' Bytes geladen und im Zwischenspeicher angehängt',2);
					}
					else{
					$daten = file_put_contents($lokaler_pfad,$daten);
						if ( strpos($socket_optionen['http']['header'],'Range:') )
						$DA->KonsolenAusgabe('Server unterstützt kein teilweises herunterladen.',2);
					$DA->KonsolenAusgabe($daten.' Bytes geladen und im Zwischenspeicher abgelegt',2);
					}
				}
				else
				$DA->KonsolenAusgabe('Es müssen mindestens 2 Kilobyte nach geladen werden',2);
			break;
			case 'file-dateigroesse':
			$DA->KonsolenAusgabe('Lade Datei von der lokalen Quelle herunter',2);
			$daten = file_get_contents($datei);
/*				// DWD sendet ein überflüssiges 0x1a ("SUB" -> ^Z) am Ende mit...
				if ( $einstellungen['daten'][$DA->cli_parameter['station']]['typus'] === 'dwd_kl2000'
					&& substr($daten,-1) === chr(0x1a) )
				$daten = substr($daten,0,-1);*/

				if ( $daten && strlen($daten) > 2048 ){
				$daten = file_put_contents($lokaler_pfad,$daten);
				$DA->KonsolenAusgabe($daten.' Bytes geladen und im Zwischenspeicher abgelegt',2);
				}
			break;
			}
		}

		switch ( $einstellungen['daten'][$DA->cli_parameter['station']]['typus'] ){
		case 'dwd_kl2000':
			if ( !$einstellungen['daten'][$DA->cli_parameter['station']]['datenformat_pruefen'] )
			break;
		$warnungen = 0;
		$neu_schreiben = false;
		$DA->KonsolenAusgabe('Überprüfe Integrität des Datenformats "dwd_kl2000"',2);
		$daten = ( file_exists($lokaler_pfad) ) ? file($lokaler_pfad) : array();
			if ( is_array($daten) && sizeof($daten) > 1 ){
			$DA->KonsolenAusgabe(sizeof($daten).' Datensätze in Roh-Datei gefunden',2);
				foreach ( $daten as $zeile=>$satz ){
					if ( strlen($satz) < 16 )
					continue;
					if ( strlen($satz) !== 284 || !in_array(substr($satz,0,2),array('KF','KG','KL','KX'),true) ){
						if ( $warnungen === 15 )
						$DA->KonsolenAusgabe('Weitere Warnungen für ungültige Zeilen werden unterdrückt',2);
						elseif ( $warnungen < 15 )
						$DA->KonsolenAusgabe('Der Datensatz '.$zeile.' enthält ein ungültiges Format',2);
					$neu_schreiben = true;
					$warnungen++;
					unset($daten[$zeile]);
					continue;
					}
				$datum = substr($satz,7,8);
					if ( $datum > $datum_reihe[0] )
					$datum_reihe[0] = $datum;
					if ( $datum < $datum_reihe[1] )
					$datum_reihe[1] = $datum;
				}
			}
		break;
		}

		if ( $neu_schreiben ){
		$DA->KonsolenAusgabe('Die Roh-Datei wurde ohne die ungültigen Datensätze neu geschrieben',2);
		file_put_contents($lokaler_pfad,implode('',$daten));
		}

		if ( file_exists($lokaler_pfad) )
		$pruefsummen[$uuid] = sha1_file($lokaler_pfad);
	}

$manifest = "<?xml version='1.0' encoding='utf-8' standalone='yes'?>
<manifest>
	<station>".$DA->cli_parameter['station']."</station>
	<zeitreihe>".$datum_reihe[1]." ".$datum_reihe[0]."</zeitreihe>
";
	foreach ( $pruefsummen as $datei=>$wert )
	$manifest .= chr(9).'<pruefsumme_'.$datei.'>'.$wert.'</pruefsumme_'.$datei.'>'.chr(10);
$manifest .= '</manifest>';
file_put_contents(str_replace($uuid,'manifest',$lokaler_pfad),$manifest);

$DA->KonsolenAusgabe('Import abgeschlossen',1);
?>
