<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 11.10.01 - Build 20.10.2011
 * Lizenziert unter 'Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)'
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
$DA->KonsolenAusgabe('Beginn der Datenverarbeitung',1);
	if ( !is_dir($einstellungen['zwischenspeicher']['speicher_pfad']) )
	$DA->KonsolenAusgabe('Das Verzeichnis für den Zwischenspeicher existiert nicht',-1);
$zwischenspeicher_groesse = 0;

	foreach ( $einstellungen['daten'] as $station_name=>$station_daten ){
		if ( extension_loaded('simplexml') ){
			if ( file_exists($einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$station_name.'.manifest') )
			$manifest = simplexml_load_file($einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$station_name.'.manifest');
		}
	echo '** '.$station_name.' **'.chr(10);
	echo chr(9).'ID: '.$station_daten['code'].chr(10);
	echo chr(9).'Name: '.$station_daten['name'].chr(10);
		if ( !empty($station_daten['kommentar']) )
		echo chr(9).'Kommentar: '.$station_daten['kommentar'].chr(10);
	echo chr(9).'Höhe: '.$station_daten['hoehe'].'m ü. NN'.chr(10);
	echo chr(9).'Position: '.$DA->GPSNachLesbar($station_daten['position']).chr(10);
	echo chr(9).'Datenlieferant: '.$station_daten['quelle'].chr(10);
		if ( isset($manifest->zeitreihe) ){
		$zeitreihe = explode(' ',$manifest->zeitreihe);
		echo chr(9).'Zeitreihe: '.$DA->ZeitstempelNachLesbar($zeitreihe[0]).' bis '.$DA->ZeitstempelNachLesbar($zeitreihe[1]).chr(10);
		}
	echo chr(9).'Rohdaten-Dateien:'.chr(10);
		foreach ( $station_daten['roh_daten'] as $id=>$datei ){
		$uuid = sprintf('%u',crc32($datei));
		$lokaler_pfad = $einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$station_name.'.'.$uuid;
		echo chr(9).chr(9).'#'.$id.' - '.basename($datei).' ==> ';
			if ( file_exists($lokaler_pfad) ){
			echo 'Vom '.strftime('%x %X',filemtime($lokaler_pfad)).', Größe '.filesize($lokaler_pfad).' Bytes'.chr(10);
			$pruefsumme = 'pruefsumme_'.$uuid;
				if ( isset($manifest) && isset($manifest->$pruefsumme) ){
					if ( sha1_file($lokaler_pfad) !== strval($manifest->$pruefsumme) )
					echo chr(9).chr(9).'HINWEIS: Datei wurde seit dem letzten Import verändert'.chr(10);
				}
			$zwischenspeicher_groesse += filesize($lokaler_pfad);
			}
			else
			echo 'Nicht im Zwischenspeicher'.chr(10);
		}
	echo chr(10).chr(10);
	unset($manifest);
	}

echo 'Der verwendete Speicherplatz im Zwischenspeicher beträgt '.round($zwischenspeicher_groesse/1000000,3).' Megabytes.'.chr(10);
?>
