<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 11.10.01 - Build 20.10.2011
 * Lizenziert unter 'Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)'
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
 *
 *           KONFIGURATIONSDATEI FÜR "WETTER-ANALYSE IN DEKADEN"
 *
 * Bei Pfadangaben wird die Tilde "~" durch das Verzeichnis, wo "WADE"
 * liegt, ersetzt. Sonst liegen normale Zahlen oder Zeichenketten vor.
 * Manche Optionen haben nur ein an = "true" oder ein aus = "false".
 * Die Einrückungen dienen nur der Übersicht.
 *  */
$einstellungen = array(
// VERFÜGBARE WETTERSTATIONEN ##########################################
	'daten'=>array(
		'Augsburg'=>array(
			'code'=>'10852',
			'name'=>'Augsburg',
			'quelle'=>'Deutscher Wetterdienst (DWD)',
			'kommentar'=>'',
			'hoehe'=>462,
			'position'=>'48.43 10.94',
			'aktualisieren'=>'http-get-dateigroesse',
			'aktualisieren_nur_neues'=>true,
			'datenformat_pruefen'=>true,
			'typus'=>'dwd_kl2000',
			'roh_daten'=>array(
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10852__1947__1999,templateId=raw,property=publicationFile.txt/kl_10852_1947_1999.txt',
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10852__00__akt__txt,templateId=raw,property=publicationFile.txt/kl_10852_00_akt_txt.txt'
			),
		),
		'Dresden'=>array(
			'code'=>'10488',
			'name'=>'Dresden-Klotzsche',
			'quelle'=>'Deutscher Wetterdienst (DWD)',
			'kommentar'=>'',
			'hoehe'=>227,
			'position'=>'51.13 13.76',
			'aktualisieren'=>'http-get-dateigroesse',
			'aktualisieren_nur_neues'=>true,
			'datenformat_pruefen'=>true,
			'typus'=>'dwd_kl2000',
			'roh_daten'=>array(
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10488__1967__1999,templateId=raw,property=publicationFile.txt/kl_10488_1967_1999.txt',
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10488__00__akt__txt,templateId=raw,property=publicationFile.txt/kl_10488_00_akt_txt.txt'
			),
		),
		'Duesseldorf'=>array(
			'code'=>'10400',
			'name'=>'Düsseldorf',
			'quelle'=>'Deutscher Wetterdienst (DWD)',
			'kommentar'=>'',
			'hoehe'=>37,
			'position'=>'51.3 6.77',
			'aktualisieren'=>'http-get-dateigroesse',
			'aktualisieren_nur_neues'=>true,
			'datenformat_pruefen'=>true,
			'typus'=>'dwd_kl2000',
			'roh_daten'=>array(
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10400__1969__1999,templateId=raw,property=publicationFile.txt/kl_10400_1969_1999.txt',
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10400__00__akt__txt,templateId=raw,property=publicationFile.txt/kl_10400_00_akt_txt.txt'
			),
		),
		'Frankfurt'=>array(
			'code'=>'10637',
			'name'=>'Frankfurt/M-Flughafen',
			'quelle'=>'Deutscher Wetterdienst (DWD)',
			'kommentar'=>'',
			'hoehe'=>112,
			'position'=>'50.05 8.6',
			'aktualisieren'=>'http-get-dateigroesse',
			'aktualisieren_nur_neues'=>true,
			'datenformat_pruefen'=>true,
			'typus'=>'dwd_kl2000',
			'roh_daten'=>array(
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10637__1949__1999,templateId=raw,property=publicationFile.txt/kl_10637_1949_1999.txt',
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10637__00__akt__txt,templateId=raw,property=publicationFile.txt/kl_10637_00_akt_txt.txt'
			),
		),
		'Hamburg'=>array(
			'code'=>'10147',
			'name'=>'Hamburg-Fuhlsbüttel',
			'quelle'=>'Deutscher Wetterdienst (DWD)',
			'kommentar'=>'',
			'hoehe'=>11,
			'position'=>'53.64 9.99',
			'aktualisieren'=>'http-get-dateigroesse',
			'aktualisieren_nur_neues'=>true,
			'datenformat_pruefen'=>true,
			'typus'=>'dwd_kl2000',
			'roh_daten'=>array(
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10147__1891__1999,templateId=raw,property=publicationFile.txt/kl_10147_1891_1999.txt',
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10147__00__akt__txt,templateId=raw,property=publicationFile.txt/kl_10147_00_akt_txt.txt'
			),
		),
		'Karlsruhe'=>array(
			'code'=>'10727',
			'name'=>'Karlsruhe',
			'quelle'=>'Deutscher Wetterdienst (DWD)',
			'kommentar'=>'',
			'hoehe'=>112,
			'position'=>'49.04 8.37',
			'aktualisieren'=>'http-get-dateigroesse',
			'aktualisieren_nur_neues'=>true,
			'datenformat_pruefen'=>true,
			'typus'=>'dwd_kl2000',
			'roh_daten'=>array(
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10727__1876__1999,templateId=raw,property=publicationFile.txt/kl_10727_1876_1999.txt',
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10727__00__akt__txt,templateId=raw,property=publicationFile.txt/kl_10727_00_akt_txt.txt'
			),
		),
		'Potsdam'=>array(
			'code'=>'10379',
			'name'=>'Potsdam',
			'quelle'=>'Deutscher Wetterdienst (DWD)',
			'kommentar'=>'',
			'hoehe'=>31,
			'position'=>'52.38 13.06',
			'aktualisieren'=>'http-get-dateigroesse',
			'aktualisieren_nur_neues'=>true,
			'datenformat_pruefen'=>true,
			'typus'=>'dwd_kl2000',
			'roh_daten'=>array(
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10379__1893__1999,templateId=raw,property=publicationFile.txt/kl_10379_1893_1999.txt',
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10379__00__akt__txt,templateId=raw,property=publicationFile.txt/kl_10379_00_akt_txt.txt'
			),
		),
		'Stuttgart'=>array(
			'code'=>'10738',
			'name'=>'Stuttgart-Echterdingen',
			'quelle'=>'Deutscher Wetterdienst (DWD)',
			'kommentar'=>'',
			'hoehe'=>371,
			'position'=>'48.69 9.23',
			'aktualisieren'=>'http-get-dateigroesse',
			'aktualisieren_nur_neues'=>true,
			'datenformat_pruefen'=>true,
			'typus'=>'dwd_kl2000',
			'roh_daten'=>array(
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10738__1953__1999,templateId=raw,property=publicationFile.txt/kl_10738_1953_1999.txt',
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10738__00__akt__txt,templateId=raw,property=publicationFile.txt/kl_10738_00_akt_txt.txt'
			),
		),
		'Zugspitze'=>array(
			'code'=>'10961',
			'name'=>'Zugspitze',
			'quelle'=>'Deutscher Wetterdienst (DWD)',
			'kommentar'=>'',
			'hoehe'=>2960,
			'position'=>'47.42 10.99',
			'aktualisieren'=>'http-get-dateigroesse',
			'aktualisieren_nur_neues'=>true,
			'datenformat_pruefen'=>true,
			'typus'=>'dwd_kl2000',
			'roh_daten'=>array(
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10961__1900__1999,templateId=raw,property=publicationFile.txt/kl_10961_1900_1999.txt',
				'http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU2/KU21/klimadaten/german/download/standardformate/kl__10961__00__akt__txt,templateId=raw,property=publicationFile.txt/kl_10961_00_akt_txt.txt'
			),
		),

	),
// ZWISCHENSPEICHER ####################################################
	'zwischenspeicher'=>array(
		'speicher_pfad'=>'~/cache',
	),
// VEKTORGRAFIK EINSTELLUNGEN ##########################################
	'grafik'=>array(
		'ausgabe_datei_maske'=>'~/export/da_%station%_%jahr%.svg',
		'breite'=>1200, // in Pixel
		'hoehe'=>600, // in Pixel
		// Alternativen sind Arial, Tahoma, Verdana oder andere
		'schriftart'=>'"dejavu sans",arial,helvetica,sans-serif',
		'schriftart_ueberschrift'=>'sawasdee,arial,helvetica,sans-serif',
		'schriftgroesse_werte_zeigen'=>'7pt',
		'diagramm_abstand'=>50, // in Pixel
		'diagramm_balken_breite'=>4, // in Pixel
		'diagramm_balken_daten'=>array(
/* Verfügbare Datenreihen: temperatur_max, temperatur_mit, temperatur_min,
 * luftdruck_mit, feuchte_mit, wind_mit, sonne, niederschlag,
 * %tropentag, %sommertag, %frosttag, %eistag, %tropennacht, %regentag
 *
 * Das Format lautet: Name, Farbe, Titel, Sichtbarkeit und Optionen
 * Die Farbe wird hexadezimal angegeben, als RGB-Tripel oder Name.
 * Für das erste findest du Auswahlhilfen im Internet. Die RGB-Werte
 * sind im Format "rgb(x,y,z)" wobei jedes eine Zahl zwischen 0 und 255
 * sein muß für Rot, Grün und Blau. Auch da gibt es Hilfsstellungen im
 * Netz. Ansonsten gehen Farbnamen auf Englisch wie "red", "green" usw.
 * Die Sichtbarkeit reicht von 0 bis 1 mit einer Nachkommastelle. "0.5"
 * entspricht zum Beispiel mit 50% halbe Sichtbarkeit.
 * Als Option gibt es derzeit nur "werte_zeigen".
 * werte_zeigen -> Am oberen Rand des Diagramms werden die Absolutwerte dargestellt
 * */
			'temperatur_mit,#ff6666,Mitteltemperatur °C,1.0',
			'temperatur_max,#ff66ff,Höchsttemperatur °C,1.0',
			'temperatur_min,#6666ff,Tiefsttemperatur °C,1.0',
			'sonne,#eecc00,Sonnenschein Stunden,1.0',
			'luftdruck_mit,#009900,Luftdruck hPa,1.0',
			'%regentag,#999999,Regentage,1.0'
			),
	),
// REPORT DATEIEN ######################################################
	'report'=>array(
		'ausgabe_datei_maske'=>'~/report/da_%station%_%aktion%_report__%paramhash%.%typ%',
	),
// DEKADEN REKORDE OPTIONEN ############################################
	'rekorde'=>array(
		'kommentar'=>'',
		'monate_anzeigen'=>'*', // * oder getrennt mit Komma z.B "6,7,8"
		'tages_rekorde_anzeigen'=>true,
		'dekaden_rekorde_anzeigen'=>true,
		'maximum_rekorde_anzeigen'=>true,
		'minimum_rekorde_anzeigen'=>true,
		'hervorheben_in_html'=>true,
		'datenreihen_auswerten'=>array(
			'temperatur_max',
			'temperatur_min',
			'temperatur_mit'
		),
	),
// WIESELFLINKE OPTIONEN ###############################################
	'wieselflink'=>array(
		'kommentar'=>'',
		'monate_anzeigen'=>'*', // * oder getrennt mit Komma z.B "6,7,8"
		'gesamt_werte_anzeigen'=>true,
		'leere_jahre_weglassen'=>true,
		'nullen_entfernen'=>false,
		'ergebnis_sortieren'=>'', // "", "aufsteigend" oder "absteigend"
	),
// HTTP-PROXY ##########################################################
	'proxy'=>array(
		'http_benutzen'=>false, // brauchst du im Regelfall nicht
		'http_hostname'=>'', // IP-Adresse/Hostname:Port
		'volle_uri_senden'=>true, // einige Proxies möchten das, andere nicht
	),
);
?>
